static __inline int BSR (uint64 bm)
{ _asm { mov  eax, dword ptr bm[4]
         test eax, eax
         jz   l_lo
         bsr  eax, eax
         add  eax, 20h
         jmp  l_ret
l_lo:    bsr  eax, dword ptr bm[0]
l_ret:
  }
}
static __inline int BSF (uint64 bm)
{ _asm { mov  eax, dword ptr bm[0]
         test eax, eax
         jz   f_hi
         bsf  eax, eax
         jmp  f_ret
f_hi:    bsf  eax, dword ptr bm[4]
         add  eax, 20h
f_ret:
  }
}
static __inline int POPCNT (uint64 w)
{
  uint32 u, v;
  u = (w & 0xffffffff);
  v = w >> 32;
  u -= ((u >> 1) & 0x55555555);
  v -= ((v >> 1) & 0x55555555);
  u = (((u >> 2) & 0x33333333) + (u & 0x33333333));
  v = (((v >> 2) & 0x33333333) + (v & 0x33333333));
  u = (((u >> 4) + u) & 0x0f0f0f0f);
  v = (((v >> 4) + v) & 0x0f0f0f0f);
  return ((u * 0x01010101) >> 24) + ((v * 0x01010101) >> 24);
}

#define bitLIBERO(b, B) B &= (B - 1)
#define bitFISSO(b, B) B |= ((uint64) 1) << (b)
